unit WMMorphBtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
TBtnStyle = (mbsStndrdBtn,mbsClose,mbsHelp,mbsMax,mbsMin,mbsRestore,MbsComboArrow,
            mbsScrlBtnDown,mbsScrlBtnLeft,mbsScrlBtnRight,mbsScrlBtnUp,mbsSizeGrip,
            mbsCheckMark,mbsBullet,mbsArrow);
TSizingMode = (mbsDesigned,mbsRealSize,mbsGlyphRealSize);
  TWMMorphBtn = class(TCustomControl)
  private
    { Private declarations }
  protected
    { Protected declarations }
    bbtnstyle:TBtnStyle;
    isenabled:Boolean;
    catstyle:integer;
    substyle:integer;
    enableval:integer;// for enabled property the value
    sizeing:TsizingMode;
    carryon :boolean;


   procedure setbtnstyle(data:TBtnStyle);
   procedure setenabled(data:Boolean);
   procedure setsizingMode(data:Tsizingmode);
  public
    { Public declarations }
   Property Canvas;
   procedure setstyles(CntrlType,CntrlState:integer);
   constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
published
    { Published declarations }
     property ButtonStyle:Tbtnstyle read bbtnstyle write setbtnstyle;
     Property Caption;
     Property Enabled:boolean read isenabled write setenabled;
     Property SizingMode:TSizingMode read sizeing write setsizingmode;
     property OnMouseDown;
     Property OnMouseUp;
     Property OnClick;
     Property OnMouseMove;
     Property ShowHint;

     Procedure Paint;override;
     procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
      procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('WAISS', [TWMMorphBtn]);
end;

//------------------------------------------------------------------------------
procedure TWMMorphBtn.setbtnstyle(data:TBtnStyle);

begin
bbtnstyle := data;
case bbtnstyle of
mbsStndrdBtn:     setstyles(dfc_button,dfcs_buttonpush);
mbsClose:         setstyles(dfc_caption,dfcs_captionclose);
mbshelp:          setstyles(dfc_caption,dfcs_captionhelp);
mbsMax:           setstyles(dfc_caption,dfcs_captionMax);
mbsMin:           setstyles(dfc_caption,dfcs_captionmin);
mbsRestore:       setstyles(dfc_caption,dfcs_CaptionRestore);
mbsComboArrow:    setstyles(dfc_scroll,dfcs_scrollcombobox);
mbsScrlBtnDown:   setstyles(dfc_scroll,DFCS_SCROLLDOWN);
mbsScrlBtnLeft:   setstyles(dfc_scroll,dfcs_scrollleft);
mbsScrlBtnRight:  setstyles(dfc_scroll,dfcs_scrollright);
mbsScrlBtnUp:     setstyles(dfc_scroll,dfcs_scrollup);
mbsSizeGrip:      setstyles(dfc_scroll,dfcs_scrollsizegrip);
mbsCheckMark:     setstyles(dfc_Menu,DFCS_MENUCHECK);
mbsBullet:        setstyles(DFC_Menu,DFCS_MENUBULLET);
mbsArrow:         setstyles(dfc_Menu,DFCS_MENUARROW);
END;

paint;

end;
//------------------------------------------------------------------------------
constructor TWMMorphBtn.Create(AOwner: TComponent);
begin
carryon := false;
inherited Create(AOwner);
top := 14;
left := 40;
Buttonstyle:=mbsStndrdBtn;
Enabled := true;
Paint;
//setstyles(dfc_button,dfcs_buttonpush);
carryon := true;  // so that paint can know that he can now
                  // draw because we have a handle
end;
//------------------------------------------------------------------------------
destructor TWMMorphBtn.Destroy;
begin
inherited destroy;
end;

//------------------------------------------------------------------------------
procedure TWMMorphBtn.setenabled(data:Boolean);
begin
isenabled:=data;
if data = false then enableval := dfcs_inactive else enableval := 0;
 paint;
end;

//------------------------------------------------------------------------------

Procedure TWMMorphBtn.Paint;
var a,b:integer;
BEGIN
 if carryon = false then exit;
drawframecontrol(canvas.handle,rect(0,0,width,height),catstyle,substyle+enableval);

if bbtnstyle =  mbsStndrdBtn then
begin
canvas.Brush.Style:=bsclear;
a := canvas.textWidth(caption) div 2;
b := canvas.TextHeight(caption) div 2;
Canvas.Font.color := clBlack;
if isenabled = true then
//graystring(canvas.handle,null,null,pchar(caption),null,a,b,null,null);

canvas.TextOut((width div 2)-a,(height div 2)-b,caption)
else
begin
canvas.Font.Color := clWhite;
 canvas.TextOut(((width div 2)-a)+1,((height div 2)-b)+1,caption);
 canvas.Font.Color := clgray;
 canvas.TextOut((width div 2)-a,(height div 2)-b,caption);
 end;
end;
end;


//------------------------------------------------------------------------------
procedure TWMMorphBtn.setstyles(CntrlType,CntrlState:integer);
begin
catstyle:=cntrltype;
substyle:=cntrlstate;
end;

//------------------------------------------------------------------------------
procedure TWMMorphBtn.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var a,b:integer;
begin
if isenabled = false then exit;
drawframecontrol(canvas.handle,rect(0,0,width,height),catstyle,substyle+dfcs_pushed);
if bbtnstyle =  mbsStndrdBtn then
begin
canvas.Brush.Style:=bsclear;
a := canvas.textWidth(caption) div 2;
b := canvas.TextHeight(caption) div 2;
canvas.TextOut(((width div 2)-a)+3,((height div 2)-b)+3,caption);
end;
inherited MouseDown(button,shift,x,y);
end;
//------------------------------------------------------------------------------
procedure TWMMorphBtn.MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
begin
if isenabled = false then exit;
paint;
//drawframecontrol(canvas.handle,rect(0,0,width,height),catstyle,substyle);
inherited MouseUp(button,shift,x,y);
inherited Click;
end;

//------------------------------------------------------------------------------
 procedure TWMMorphBtn.setsizingMode(data:Tsizingmode);
 begin
 sizeing := data;
 if data = mbsRealSize then
 begin
 case catstyle of
 DFC_CAPTION:begin
             height := 14;
             Width := 16;
             end;
 dfc_Menu:   Begin
             height :=16;
             Width :=16;
             end;
 dfc_Scroll: Begin
             Height :=16;
             Width :=14;
             end;
 end;
 paint;
 end;
 end;
end.
